
// Column connections
sbit Col1 at RB4_bit;
sbit Col2 at RB5_bit;
sbit Col3 at RB6_bit;
sbit Col4 at RB7_bit;

// Define LCD connections
sbit LCD_RS at RA6_bit;
sbit LCD_EN at RA7_bit;
sbit LCD_D4 at RA0_bit;
sbit LCD_D5 at RA1_bit;
sbit LCD_D6 at RA2_bit;
sbit LCD_D7 at RA3_bit;
sbit LCD_RS_Direction at TRISA6_bit;
sbit LCD_EN_Direction at TRISA7_bit;
sbit LCD_D4_Direction at TRISA0_bit;
sbit LCD_D5_Direction at TRISA1_bit;
sbit LCD_D6_Direction at TRISA2_bit;
sbit LCD_D7_Direction at TRISA3_bit;
// End LCD module connections

// Define Messages
char message1[] = "Hit Key:";

void Debounce(){
 Delay_ms(50);
}

char Get_Key(){
  // Scan row 1
  PORTB = 0b00001110;
  if (!Col1){
   Debounce();
   return 0x31;
  }
  if (!Col2){
   Debounce();
   return 0x32;
  }
  if (!Col3){
   Debounce();
   return 0x33;
  }
  if (!Col4){
   Debounce();
   return 0x41;
  }
  // Scan row 2
  PORTB = 0b00001101;
  if (!Col1){
   Debounce();
   return 0x34;
  }
  if (!Col2){
   Debounce();
   return 0x35;
  }
  if (!Col3){
   Debounce();
   return 0x36;
  }
  if (!Col4){
   Debounce();
   return 0x42;
  }
  // Scan row 3
  PORTB = 0b00001011;
  if (!Col1){
   Debounce();
   return 0x37;
  }
  if (!Col2){
   Debounce();
   return 0x38;
  }
  if (!Col3){
   Debounce();
   return 0x39;
  }
  if (!Col4){
   Debounce();
   return 0x43;
  }
 // Scan row 4
  PORTB = 0b00000111;
  if (!Col1){
   Debounce();
   return 0x2A;
  }
  if (!Col2){
   Debounce();
   return 0x30;
  }
  if (!Col3){
   Debounce();
   return 0x23;
  }
  if (!Col4){
   Debounce();
   return 0x44;
  }
 return ' ';

}

void main() {
 char key[] = " ";
 TRISA  = 0b00100000;   // PORTA output except RA5
 TRISB  = 0b11110000;   // R1-R4 output, C1-C4 input
 ANSELA = 0x00;         // Disable any analog functions in PORTA
 ANSELB = 0x00;         // Disable any analog functions in PORTB
 OPTION_REG = 0x00;
 PORTB  = 0b00001111;   // All rows equal to 1
 Lcd_Init();
 Lcd_Cmd(_LCD_CLEAR);             // CLEAR display
 Lcd_Cmd(_LCD_CURSOR_OFF);        // Cursor off
 Lcd_Out(1,1,message1);           // Write message1 in 1st row
 WPUB   = 0b11110000;             // RB3-RB7 pull-up enabled
 do {
  key[0] = Get_Key();
  if (key[0] != ' ') Lcd_Out(2,7,key);
 }while(1);
}